 version: '3'
 
 services:
   # Define a Mosquitto (MQTT) service
   mosquitto:
     image: eclipse-mosquitto:latest
     volumes:
       - ./mosquitto/data:/mosquitto/data
       - ./mosquitto/log:/mosquitto/log
       - ./mosquitto/mosquitto.conf:/mosquitto/config/mosquitto.conf
     restart: always
     ports:
       - "1883:1883"
       - "9001:9001"
 
   # Define a Telegraf service
   telegraf:
     image: telegraf:latest
     volumes:
       - ./telegraf/telegraf.conf:/etc/telegraf/telegraf.conf
     links:
       - influxdb
     restart: always
     ports:
       - "8092:8092/udp"
       - "8094:8094"
       - "8125:8125/udp"
 
   # Define an InfluxDB service
   influxdb:
     image: influxdb:latest
     volumes:
       - ./influxdb/data/influxdb:/var/lib/influxdb
     restart: always
     ports:
       - "8086:8086"
 
   # Define a Chronograf service
   chronograf:
     image: chronograf:latest
     volumes:
       - ./chronograf:/var/lib/chronograf
     environment:
       INFLUXDB_URL: http://influxdb:8086
       KAPACITOR_URL: http://kapacitor:9092
     restart: always
     ports:
       - "8888:8888"
     links:
       - influxdb
       - kapacitor
 
   # Define a Kapacitor service
   kapacitor:
     image: kapacitor:latest
     volumes:
       - ./kapacitor/kapacitor.conf:/etc/kapacitor/kapacitor.conf
     environment:
       KAPACITOR_HOSTNAME: kapacitor
       KAPACITOR_INFLUXDB_0_URLS_0: http://influxdb:8086
     links:
       - influxdb
     restart: always
     ports:
       - "9092:9092"
